package com.cringe_studios.cringe_authenticator_library;

import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

public enum OTPAlgorithm{
	SHA1  ("HmacSHA1"),
	SHA224("HmacSHA224"),
	SHA256("HmacSHA256"),
	SHA384("HmacSHA384"),
	SHA512("HmacSHA512"),
	MD5   ("HmacMD5");
	
	
	private String javaName;
	
	private OTPAlgorithm(String nJavaName) {
		javaName = nJavaName;
	}
	
	public String getJavaName() {
		return javaName;
	}
	
	public byte[] hash(byte[] keyBytes, byte[] text) throws InvalidKeyException, NoSuchAlgorithmException {
		Mac hmac;
		hmac = Mac.getInstance(this.getJavaName());
		
		SecretKeySpec macKey = new SecretKeySpec(keyBytes, "RAW");
		
		hmac.init(macKey);
		return hmac.doFinal(text);
	}
}